Добавлены переменные для мониторинга загрузки CPU и использования оперативной памяти. Пакет libopenssl обновлен до версии 3.5.6.
При регистрации канального окончания на сервере в поле `Contact` указывается домен 127.0.0.1. Это устраняет потенциальные проблемы в случае регистрации канального окончания на собственном сервере платы при изменении IP адреса. Пакет libopenssl обновлен до версии 3.5.5. Пакет dnsmasq обновлен до версии 2.92. Пакет wget-nossl обновлен до версии 1.25.0.
Исправлена ошибка: канальное окончание FO01 "не видело" сигнал вызова на платах VE-02 до версии 9.
Улучшена работа канальных окончаний R232, R422, R485: ранее при ненулевом значении параметра "Таймаут передачи" и неготовности TCP сокета к записи данных повторная попытка записи производилась после повторного истечения таймаута, что при больших значениях таймаута приводило к ненужным задержкам. Теперь повторная попытка записи производится каждую милисекунду. В канальных окончаниях R232, R422, R485 устранена возможная потеря принимаемых данных. Исправлена ошибка: в канальном окончании R232 не работало управление потоком. Исправлена ошибка: при определенных условиях после разрыва TCP соединения буфер данных не очищался, и продолжались попытки передать данные в закрытый сокет, что приводило к большому количеству сообщений об ошибке в журнале.
Пакет resiprocate обновлен до версии 1.13.2. Пакет libopenssl обновлен до версии 3.5.2. Пакет dropbear обновлен до версии 2025.88. Пакет libcares обновлен до версии 1.34.5. Пакет libpcre2 обновлен до версии 10.46.
Исправлена ошибка: отсутствовало прохождение речевого сигнала от сменных модулей к медиапроцессору.
Улучшение: плата индицирует состояние и параметры (скорость, дуплекс) соединения внешнего порта ethernet ("LAN"). Улучшение: плата индицирует типы установленных в ней сменных модулей. Улучшение: UART, работающий с канальными окончаниями R232, R422, R485 теперь контролирует ошибки четности и фрейма. Добавлены счетчики ошибок четности и фрейма. Исправлена ошибка: канальные окончания R232, R422, R485 не передавали данные.
Исправлена ошибка: не работала генерация последовательностей импульсов СУВ в каналы TDM. Функция использовалась канальными окончаниями 1IND, R1.5, FXO (в режиме испульсного набора), EM (в режиме испульсного набора). Ошибка была внесена в прошивке ревизии 57.
Добавлена поддержка атрибутов crypto в RTP/AVP в принятом предложении SDP. Добавлена поддержка модуля 4W01. Канальное окончание, которое ранее отображалось в веб-интерфейсе как "EM01", теперь отображается как "RTP". Добавлена поддержка новых версий платы (v9+). Улучшение: "виртуальные" (IP-only) каналы (например голосовые анонсы) теперь могут использовать SRTP. Ранее для таких каналов был доступен только RTP. Исправлена ошибка: при вызове SIP пользователя через транспорт TLS с указанием в URI номера порта контакт не находился на сервере регистрации, и вызывающий получал ответ "480 Temporary unavailable" как будто вызываемый не зарегистрирован. Исправлена ошибка: при выборе медиапотока в принятом предложении SDP в некоторых случаях могли применяться атрибуты recvonly/sendonly/inactive другого (не бывранного) медиапотока.
Устранена проблема "зависания" канального окончание SL в состоянии `Blocked`. Исправлена ошибка: при получении сообщения ACK могла производиться повторная валидация ответа SDP, приводившая к установкам неверных медиа-параметров канала. Исправлена ошибка: при извлечении из сообщения SIP DisplayName в форме quoted-string не удалялись экранирующие символы '\'. Исправлена ошибка: канальные окончания PRI, SS7, FXO при формировании INVITE не кодировали DisplayName вызывающего абонента в quoted-string, в результате чего могли формироваться некорректные значения name-addr.
Исправлена ошибка: канальное окончание R1.5 передавало неверную комбинацию СУВ если во время передачи кодограммы АОН происходил отбой.
Добавлена проверка на адрес 0.0.0.0 в сообщениях SDP ('старый' холд).
Библиотека openssl обновлена до версии 3.4.0. Исправлена ошибка, которая могла приводить к перезагрузкам платы при использовании конференций.
Канальному окончанию FXO добавлен конфигурационный флаг "Инверсия СУВ". Библиотека openssl обновлена до версии 3.1.7.
Улучшен вывод в syslog - увеличен размер очереди сообщений. Конфигурационный параметр "Принимать 3.1k audio" перенесен из канального окончания SS7 в настройки SSP. Канальное окончание SS7 передает подадрес (subaddress) вызываемого и вызывающего абонентов из параметра Access Transport сообщения IAM в сообщение INVITE и обратно. Канальное окончание SS7 при получении сообщений CON и ANM передает в сообщение "200 OK" подадрес (subaddress) подключенного (ответившего) абонента. При получении сообщения "200 OK" подадрес ответившего абонента передается в сообщении CON/ANM. Канальное окончание SS7 при получении сообщения IAM с несуществующим кодом CIC передает сообщение REL (ранее такое сообщение IAM игнорировалось). Канальное окончание SS7 при формировании индикатора Calling-Party-Category в сообщении IAM кроме числовых значений параметра URI "cpc" принимаются также строковые значнеия "operator", "ordinary", "test", "payphone" и т.п. Канальное окончание SS7 при отправке сообщений IAM поле Nature of Address Indicator вызываемого абонента устанавливает в значение 2 (Unknown). SSP SS7 добавлены конфигурационные параметры SIP, как у большинства других канальных окончаний SIP. Исправлена ошибка: получение канальным окончанием SS7 тестового вызова (сообщения IAM с категорией вызывающего абонента "test call") снимало удаленную блокировку канала. Исправлена ошибка: при отсутствии информации о вызывающем абоненте (caller-ID) поля P-Asserted-Identity и/или Ramote-Part-ID использовали отображаемое имя и имя пользователя из URI канального окончания. Теперь при отсутствии caller-ID поля PAI/RPID в сообщение INVITE не добавляются. Исправлена ошибка: при некоторых условиях сигнальные линки SS7lnk могли не передавать данные в канал TDM, Исправлена ошибка: при изменении варианта протокола (ITU/ANSI) SSP параметры APC/DPC привязанных к нему канальных окончаний SS7 и SS7lnk, заданные в формате "a-b-c", не обновлялись (их интерпретация зависит от варианта протокола - "3-8-3" или "8-8-8"). Исправлена ошибка: полупостоянные потоки RTP не применяли настройки режима буферизации "на лету."
Добавлена возможность подключаться к одной полупостоянной конференции по разным URI и автоматически вызывать разных участников в зависимости от использованного URI. Добавлены конфигурационные параметры "Рег. выражение вызова", "Автоматический вызов" (для рег. выражения вызова) и "Спикеры". При выходе последнего спикера из конференции оставшиеся участники отбиваются. Канальному окончанию PRI добавлен конфигурационный флаг, позволяющий настроить режим идентификации B-канала (Preferred или Exclusive) при исходящем вызове (в сообщении SETUP). Канальному окончанию PRI добавлена функция блокировки B-каналов для входящих вызовов. При получении SETUP с указанием заблокированного канала в режиме Preferred канальное окончание PRI выбирает другой свободный незаблокированный канал. Канальному окончанию PRI добавлены конфигурационные параметры, позволяющие задавать исключения блокировки B-каналов для входящих и для исходящих вызовов в зависимости от номера вызываемого и/или вызывающего абонентов. Канальному окончанию PRI добавлены конфигурационные параметры, позволяющие задавать тип номера (Type-of-Number) и индикатор плана нумерации (Numbering-Plan-Indicator). Улучшена валидация канальным окончанием PRI сигнальных сообщений, получаемых в ответ на SETUP. Канальное окончание PRI передает подадрес (subaddress) вызываемого и вызывающего абонентов из сообщения SETUP в сообщение INVITE и обратно. Канальное окончание PRI при получении сообщения CONNECT передает в сообщение "200 OK" идентификацию подключенного (ответившего) абонента (имя, адрес, подадрес). При получении сообщения "200 OK" идентификация ответившего абонента передается в сообщении CONNECT. Исправлена ошибка: канальное окончание PRI при получении ответа "183 Session Progress" вместо сообщения PROGRESS отправляло сообщение ALERTING.
Добавлена поддержка регулярных выражений PCRE2. Канальному окончанию PRI добавлена возможность блокировки исходящих вызовов для каждого B-канала.
Исправлена ошибка, которая могла приводить к перезагрузке при выводе в журнал некоторых сообщений Q.931 канальным окончанием PRI.
Добавлена поддержка канального окончания R1.5.
Исправлена ошибка декодирования кодограммы АОН: если последним принятым символом был символ "повтор", вся кодограмма ошибочно считалась невалидной. Библиотека openssl обновлена до версии 3.1.4. Библиотека c-ares обновлена до версии 1.23.0. Библиотека libosip2 обновлена до версии 5.3.1. Библиотека libeXosip2 обновлена до версии 5.3.0. Библиотека libpcap обновлена до версии 1.9.1. Утилита tcpdump обновлена до версии 4.9.2.
Исправлена ошибка: при получении ACK соответствующее событие не передавалось канальным окончаниям, что могло приводить к неправильной работе перехвата вызовов.
Библиотеки libcrypto и libssl обновлены до версии 3.1.2.
Пакет dnsmasq обновлен до версии 2.89. Пакет dropbear обновлен до версии 2022.83. Библиотеки libpcre и libpcrecpp обновлены до версии 8.45. Библиотека libpri обновлена до версии 1.6.1.
Канальное окончание DS поддерживает сообщение REFER вне диалога. Исправлена ошибка, приводившая к отбою сразу после ответа удаленного вызываемого абонента в сценариях, когда ответ на предложение SDP был получен в надежном предварительном ответе, а не в окончательном ответе.
Новая функция "Proxy ARP". При включении "Proxy ARP" плата отвечает на запросы ARP, полученные из интерфейса WAN (eth0), если запрошенный адрес принадлежит интерфейсу LAN (eth2). Канальные окончания R232, R422, R485 собирают статистику и могут выдавать ее по запросу. Исправлена ошибка: при отсутствии сигнальных линков канальных окончаний PRI и SS7 вызывающий получал ответ 404 и голосовое сообщение "номер не существует". Теперь возвращается ответ 480. Канальные окончания, работающие с соединительными линиями (SS7, PRI, АДАСЭ, EM, FXO, 1IND, R2, R2DTMF, SL) при занятости разговорных каналов возвращают ответ 480 (было 486).
Реализовано создание, конфигурирование и удаление статических конференций. Канальные окончания RTP индицируют состояние "Error" миганием и состояние "Rem. host down" постоянным свечением желтого светодиода соответствующего порта. Канальным окончаниям R232, R422 и R485 добавлена возможность конфигурации числа битов данных в символе. Этим же канальным окончаниям в настройке числа стоп-бит добавленв вариант 1.5. Реализована подписка на события конференции в соответствии с RFC4579 и RFC4575. Добавлена поддержка отображения серийного номера на вкладке "Инвентаризация" веб-интерфейсе блока. Релизована обработка конференциями сообщения REFER вне диалога INVITE.
Канальному окончанию PRI добален конфигурационный параметр "Префикс межгорода" и конфигурационный флаг "Дополнительный гудок". Если флаг установлен, после набора префикса межгорода в канал выдается дополнительный сигнал "Готовность".
При установке модулей EM01 их интерфейсы теперь можно использовать не только как канал ТЧ (полупостоянный поток RTP), но и как E&M (канальное окончание EM).
Исправлена ошибка: при вызове в чужой домен не выполнялся маскарадинг INVITE и блокировки исходящих вызовов.
Добавлена функция "Маскарадинг INVITE" для сообщений INVITE, передаваемых внешними UA через прокси-сервер платы VE-02. Если домен в поле From принадлежит плате, домен в поле Contact устанавливается таким же, как в поле From. Функция "Маскарадинг INVITE" для канальных окончаний шлюза теперь работает аналогично - если домен в поле From принадлежит плате, домен в поле Contact устанавливается таким же, как в поле From. Исправлена ошибка, которая при большом числе сконфигурированных SIP-пользователей могла приводить к "потере" платой части пользователей.
Исправлена ошибка: поток RTP от канальных окончаний шлюза не передавался в интерфейс LAN (eth2).
Добавлена возможность настройки альтернативного сервера NTP.
Улучшен механизм форвардинга медиапакетов, принимаемых через интерфейс LAN, в MSP. Устранены передававшиеся ранее сообщения ICMP port unreachable.
Канальному окончанию DS добавлен конфигурационный параметр, устанавливающий сигнал, передаваемый в канал TDM при подключении оператора.
Канальному окончанию FXS добавлен конфигурационный флаг "Инверсия СУВ". Когда в ответе SDP отвергается медиапоток, в целях уменьшения размера сообщения не указываются атрибуты отвергнутого медиапотока. В ситуации, когда в ответ на INVITE несколько раз приходит ответ "180 Ringing", генерация КПВ включается только один раз. Добавлена поддержка регулярного выражения from URI в маршрутах SIP. В ответах на INVITE вместо Remote-Party-ID передается P-Asserted-Identity.
Канальному окончанию R2DTMF добавлен конфигуарционный параметр "Таймаут набора". Если в параметре "Горячая линия" канального окончания FXS указан домен (есть символ '@'), то указанный домен используется при отправке INVITE и имеет приоритет перед другими конфигурационными параметрами ("To домен" и "SIP URI"). Улучшен алгоритм отбоя по таймауту RTP. Теперь отбой по таймауту выполняется даже в случае, когда канальное окончание не получило ни одного пакета RTP (ранее в описанном случае отбой не происходил). Добавлен глобальный флаг "Маскарадинг INVITE", при установке которого в поле Contact исходящего запроса INVITE указываются адрес и порт внешнего интерфейса платы. При получении Caller-ID "непечатные" символы заменяются на '?'. При записи журнала в файл сохраняется 10 последних файлов (ранее сохранялся один). Также размер файлов увеличен до 10 Мбайт. Исправлена ошибка: если канальное окончание FXO не могло отправить INVITE в сеть, после отбоя вызова веб-интерфейс продолжал отображать имя вызывающего абонента. Исправлена ошибка: в некоторых случаях, когда выполнялся отбой сразу после отправки INVITE (до установки диалога), сообщение CANCEL не отправлялось в сеть, но успешность отправки не проверялась, в результате сессия "зависала". Исправлены ошибки: при передаче ответа в сеть IP не проверялась успешность отправки "200 OK". В случаях, когда непосрадственно перед ответом было принято CANCEL, канальное окончание могло "зависнуть" в занятом состоянии. Теперь при неуспешной отправке ответа выполняется отбой. Исправлена ошибка: в некоторых случаях, когда сразу после INVITE из сети IP принималось CANCEL, отбой не обрабатывался канальным окончанием, в результате чего канальное окончание "зависало" в занятом состоянии.
Канальное окончание FXO передает причину отбоя при отбое из-за отсутствия dialtone (502 "No dialtone") и при отбое по прекращению сигналов вызова TDM до ответа со стороны SIP (487 "ORIGINATOR_CANCEL"). Добавлен новый глобальный параметр "T1" для установки таймаута SIP T1. Отключен авто-маскарадинг контакта при регистрации, приводивший к неверному адресу хоста в поле Contact сообщений REGISTER. Исправлена ошибка: при получении ответа 1xx или при получении ACK неверно проверялось наличие SDP в принятом сообщении. В результате был возможен ложный отбой с причиной "Incompatible media parameters".
Добавлена поддержка сигнализации SS7. В большинстве случаев отбоя в сообщении SIP указывается причина в поле Reason. При отбое со стороны SIP и наличии в сообщении поля Reason указанная в нем причина транслируется в сеть TDM, если это поддерживается используемой системой сигнализации (PRI, SS7). Библиотека openssl обновлена до версии 1.1.1l. Библиотеки libosip2 и libexosip2 обновлены до версии 5.2.1. SSH сервер dropbear обновлен до версии 2020.81. resiprocate обновлен до версии 1.12.0. Устранена проблема, которая могла приводить к незапуску DHCP клиента, что приводило к отсутствию у платы сетевых настроек. Устранена проблема: при некоторых условиях (смена используемого кодека EVRC* на кодек не-EVRC* без пересоздания канала при включенной функции VAD) активация медиапотока могла заканчиваться ошибкой и даже приводить к перезагрузке платы.
Исправлена ошибка, приводившая к искажению передаваемых символов интерфейсами RS-232/RS-422/RS-485 (канальные окончания R232/R422/R485).
В полупостоянных потоках RTP при использовании кодеков GSM, GSM-EFR, GSM-HR-08, AMR, EVRC, EVRC0, EVRCB, EVRCB0 авария LOS формируется даже при использовании VAD. Добавлена функция ping. Добавлена поддержка модулей R232 и R485. Модулю R422 добавлена настройка скорости. Модуль R422 теперь может устанавливаться как на место 1, так и на место 2.
Канальному окончанию PPS добавлены конфигурационные параметры, устанавливающие передаваемый в канал и принимаемый из канала (дополнительный) сигналы включения ретрансляторов.
Добавлен дополнительный контроль наличия процессов udhcpc (DHCP клиент) и ntpclient (NTP клиент). Если обнаруживается отсутствие процесса в то время, как он должен работать, процесс перезапускается. Реализована функция "громкого боя" для SIP-пользователей. В канальном окончании АДАСЭ устранены ненужные паузы после передачи в канал сигнала "ЗАНЯТИЕ" если не требуется передача номера. Канальному окончанию АДАСЭ добавлена возможность делать дополнительную паузу в процессе набора номера. Канальным окончаниям АДАСЭ и FXO добавлена возможность настройки длительности межсерийного интервала при передаче номера импульсным способом.
Добавлен глобальный параметр исключений блокировок исходящих вызовов. Исправлена ошибка: в плату SW-01 не передавались обновления состояния канала 256.
Канальному окончанию PRI добавлен конфигурационный параметр "Рег. выражение набора". Исправлена ошибка: если соединение разрывалось в момент приема из канала TDM сигнала DTMF, некоторые канальные окончания при следующей активации медиапотока могли передавать пакеты RTP RFC2833 с окончанием DTMF предыдущего сеанса.
В канальном окончании FO01 добавлен периодический контроль состояния кофидека. При обнаружении потери кофидеком конфигурации выполняется реинициализация модуля FO01. Реализована маршрутизация пакетов RTP/RTCP между канальными окончаниями шлюза и устройством (IP-телефоном), подключенным к интерфейсу LAN.
Канальному окончанию FS01 добавлена функция "громкого боя".
В канальном окончании АДАСЭ расширен диапазон уровней приема сигналов 1200 Гц и 1600 Гц: порог детектирования сигналов снижен до -17 дБм. При получении шлюзом не-INVITE запроса с Replaces возвращается ответ "400 Bad request". Устранен ненужный рестарт прокси-сервера в случае, когда плате передается конфигурация без сертификата SSL, и в текущей конфигурации сертификата также нет. Устранена ошибка, которая в некоторых случаях могла возникать при записи конфигурации в плату после изменения режима журналирования, приводившая к перезагрузке платы.
Исправлена ошибка, канальное окончание R422 в режиме сервера не активировало TCP keepalive при подключении клиента.
Исправлена ошибка, приводившая к разрыву соединения канальным окончанием R422 при заполнении буфера передачи UART.
Добавлен новый тип канального окончания DS (диспетчерская конференция через групповой канал TDM). Канальному окончанию R422 добавлен конфигурационный параметр "Таймаут передачи" и функция задержанной передачи. Исправлена работа VAD в полупостоянных потоках RTP: изменение настройки теперь применяется при startRTP().
Исправлена ошибка, которая могла приводить к перезагрузке при изменении сетевых настроек.
Добавлена поддержка модуля R422 (передача данных RS-422 через TCP). Добавлен конфигурационный флаг, предписывающий аутентифицировать сообщения SIP, адресованные нашему домену из чужих доменов. Канальным окончаниям SIP добавлен конфигурационный параметр Realm.
Пользователям SIP добавлена функция блокировки входящих и/или исходящих вызовов с возможностью задания исключений блокировки. При выполнении передачи вызова в SIP сообщениях REFER и INVITE с полем Replaces добавлено поле Referred-By с указанием инициатора перпедачи вызова. Значение поля SSRC в потоках RTP сделано более случайным.
В сообщениях RTCP передаются более точные временные отметки (синхронизируются по NTP). Для более быстрой синхронизации системного времени с сервером платы SW-01 (а также для случаев, когда с платой SW-01 по каким-то причинам нет связи через сеть) начальная установка системных часов производится по времени, получаемому от платы SW-01 по управляющей шине SPI.
Исправлена ошибка, которая могла приводить к отсутствию медиапотока (и, как следствие, слышимости) у некоторых канальных окончаний при повторных вызовах.
Добавлена поддержка сигнализации E&M (канальное окончание EM). Поддерживаются варианты "немедленный старт", "wink" и "задержка старта". Добавлена поддержка систем сигнализаций частотами 2100 Гц, 2600 Гц и 600+750 Гц, используемых на ведомственных сетях связи (канальное окончание SL). Добавлены глобальные настройки, определяющие, в каких полях сообщений SIP канальное окончание отправляет и принимает Caller-ID: From, Remote-Party-ID и/или P-Asserted-Identity. Канальное окончание PRI теперь транслирует отображаемое имя вызывающего абонента при вызове со стороны TDM в сторону сети IP. При изменении приоритета журналирования, если режим журналирования остается неизменным, перезапуск syslogd не производится. Исправлена ошибка: если канальное окончание PRI не могло отправить INVITE в сеть IP, соответствующий канал возвращался в исходное состояние, но не отправлял DISCONNECT в сторону сети TDM. Также в веб-интерфейсе в состоянии канала продолжали отображаться имя и номер вызывающего абонента. Исправлена ошибка: при нахождении канального окончания в режиме VBD в веб-интерфейсе вместо "VBD" могло отображаться название кодека, выбранного для передачи речи. Исправлена ошибка: если канальное окончание АДАСЭ получало "отбой" со стороны TDM в состоянии Calling, то после перехода в исходное в канал продолжал передаваться сигнал КПВ. Исправлена ошибка: при включении избыточности для полупостоянного потока RTP поток RTP генерировался, но не принимался платой.
Канальное окончание FXO теперь может передавать номер вызываемого абонента декадными импульсами. Канальным окончаниям FXS добавлен конфигурационный флаг, позволяющий принимать декадно-импульсный набор номера даже при больших отклонениях параметров импульсов от требуемых стандартами (например от аппаратов с дисковыми номеронабирателями). Добавлена возможность изменять настройки журналирования платы записью значения переменной (через веб-интерфейс). Исправлена ошибка: если канальному окончанию установлен флаг "Принимать только TLS", при получении INVITE через небезопасный транспорт код ответа устанавливался в 486 даже если вызываемый URI не совпадал с URI канальных окончаний.
Устранена проблема ложного разрыва соединений по таймауту RTP. Устранена проблема отсутствия связи с платой по IPv6 из-за неприема некоторых мультикастовых пакетов, в том числе запросов NDP.
Устранен вывод в журнал ложного сообщения "starting RTP stream to ...", который мог происходить через 2 минуты после старта медиапотока. Исправлена ошибка: при использовании функции Session Timer для обновления таймера шлюз мог генерировать сообщения UPDATE с неверным значением хоста в поле Contact.
Добавлен новый тип канального окончания - МБ (2100 Гц).
Добавлена поддержка модуля EM01.
Добавлена поддержка модуля FO01 (канальное окончание FO01). Исправлена ошибка: таймер длительности соединения мог перезапускаться при REINVITE, например при постановке на холд или снятии с холда. Теперь этот таймер запускается только один раз.
Библиотека openssl обновлена до версии 1.0.2q. Библиотека c-ares обновлена до версии 1.15.0. Библиотека pcre обновлена до версии 8.42. Добавлен новый тип канального окончания: R2DTMF. Оптимизирован алгоритм обработки ответа на предложение SDP: в некоторых случаях устранено ненужное пересоздание медиапотока при ответе абонента, приводившее к заметному на слух прерыванию звука. Улучшен алгоритм активации медиапотока и генерации сигнала КПВ: теперь медиапоток всегда имеет приоритет, а местный сигнал КПВ генерируется при получении ответа 180 только в случае отсутствия медиапотока. Исправлены опечатки в выводимых в системный журнал сообщениях. Исправлена ошибка, которая могла приводить к перезагрузке платы в случае завершения транзакции INVITE по таймауту.
Первая ревизия прошивки для кассеты 3U.